void draw_formula(int posx, float posy, int posz){
  pushMatrix();
  translate(posx, posy, posz);
  textSize(4);
  fill(#ffa600);
  text(" = -34.5 + 0.05 *               - 21.92 *        + 22.93 *        + 14.18 *        + 40.64 *         - 19.46 *        ",0,0,0);
  popMatrix();
}

void insert_number(TableRow nn_data_row, int posx){
  float profileVisit = nn_data_row.getFloat(2); 
  float countryDE = nn_data_row.getFloat(23);
  float countryFR = nn_data_row.getFloat(24);
  float countryOther = nn_data_row.getFloat(25);
  float isNew = nn_data_row.getFloat(10);
  float verified = nn_data_row.getFloat(17);
  
  draw_number(profileVisit, posx-41,-90, 0);
  draw_number(countryDE, posx - 12 ,-90, 0);
  draw_number(countryFR, posx +11,-90, 0);
  draw_number(countryOther, posx + 34 ,-90, 0);
  draw_number(isNew, posx +57 ,-90, 0);
  draw_number(verified, posx+81 ,-90, 0);
}


void draw_number(float number, int posx, int posy, int posz){
  pushMatrix();
  translate(posx, posy, posz);
  textSize(4);
  fill(#ffa600);
  String s = nf(number, 0, 2);
  text(s,0,0,0);
  popMatrix();
}


void draw_linear_labels(color mycolor){
  fill(mycolor);
  
  textSize(30);
  pushMatrix();
  textAlign(LEFT, TOP);
  translate(-60, 60, 60);
  scale(0.1);
  text("log(Pictures + 1): 0", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, TOP);
  translate(60, 60, 60);
  scale(0.1);
  text("log(Pictures + 1): 3.5", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, TOP);
  translate(-60, -60, 60);
  scale(0.1);
  text("visit: 0", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, BOTTOM);
  translate(-60, 60, 60);
  scale(0.1);
  text("log(visit + 1): 12.1", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(LEFT, CENTER);
  translate(60, 60, 60);
  scale(0.1);
  text("log(fans + 1): 0", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(LEFT, CENTER);
  translate(60, 60, -60);
  scale(0.1);
  text("log(fans + 1): 5.5", 0, 0, 0);
  popMatrix();
}

void label_operation(color mycolor){

String a = "Move close to the point to see its info.";
String d = "Press space bar to restart generation";
String b = "Drag mouse to rotate around";
String c = "Press s to stop generating"; 

fill(mycolor);
textSize(40);
pushMatrix();
translate(-20,95, 0);
scale(0.1);
text(a, 0,0,0);
popMatrix();

pushMatrix();
translate(-20,100, 0);
scale(0.1);
text(d, 0,0,0);
popMatrix();

pushMatrix();
translate(-20,105, 0);
scale(0.1);
text(b, 0,0,0);
popMatrix();


pushMatrix();
translate(-20,110, 0);
scale(0.1);
text(c, 0,0,0);
popMatrix();
}

void linear_input_label(){
  String a = "Profile_Visit";
  String b = "DE"; 
  String c = "FR"; 
  String d = "Other";
  String e = "isNew";
  String f = "verified";
  
  fill(#ffa600);
  textSize(30);
  
  pushMatrix();
  translate(-48,-95, 0);
  scale(0.1);
  text(a, 0,0,0);
  popMatrix();
  
  pushMatrix();
  translate(-17,-95, 0);
  scale(0.1);
  text(b, 0,0,0);
  popMatrix();
  
  pushMatrix();
  translate(6,-95, 0);
  scale(0.1);
  text(c, 0,0,0);
  popMatrix();
  
  
  pushMatrix();
  translate(28,-95, 0);
  scale(0.1);
  text(d, 0,0,0);
  popMatrix();
  
  pushMatrix();
  translate(51,-95, 0);
  scale(0.1);
  text(e, 0,0,0);
  popMatrix();
  
  pushMatrix();
  translate(74,-95, 0);
  scale(0.1);
  text(f, 0,0,0);
  popMatrix();
}
