void draw_nn_work(int posx, int posz, int diff, color ballColor,  TableRow nn_data_row){
  int feature_index = 0;
  
  String[] col_names = {"age", "counts_pictures", "counts_profileVisits", "counts_kisses",
       "counts_fans", "flirtInterests_chat", "flirtInterests_friends",
       "flirtInterests_date", "isFlirtstar", "isMobile", "isNew", "isVip",
       "lang_count", "lang_fr", "lang_en", "lang_de", "lang_it", "verified",
       "F", "M", "both", "none", "CH", "DE", "FR", "Other"};
       
  for (int i = 0; i < 25; i++){
    if (feature_index == 3){
      feature_index += 1;
    }
    pushMatrix();
    mouse_nn_interact(posx - 2*diff, -29 + 3*i, posz, col_names[feature_index], ballColor);
    float ballscale = map(log(nn_data_row.getFloat(feature_index)+2), log(feature_range[feature_index * 2]+2), log(feature_range[feature_index * 2 + 1]+2), 10, 20);
    translate((1-(ballscale))* (posx - 2*diff), (1 - ballscale) * (-29 + 3*i),  (1- ballscale)*(posz));
    scale(ballscale);
    point(posx - 2*diff, -29 + 3*i, posz);
    popMatrix();
    
    feature_index += 1; 
  }
  
  
  draw_nn_points(32, ballColor, 0, posx, -41, posz, -diff);
  draw_nn_points(64, ballColor, 32, posx, -82, posz, 0);
  draw_nn_points(32, ballColor, 96, posx, -41, posz, diff);
  draw_nn_points(16, ballColor, 128, posx, -19, posz, 2*diff);
  draw_nn_points(8, ballColor, 144, posx, -8, posz, 3*diff);
  draw_nn_points(4, ballColor, 152, posx, -3, posz, 4*diff);
  draw_nn_points(1, ballColor,  156, posx, 1.5, posz, 5*diff); 
}



void connect_network(int posx, int posz, int diff, color linecolor, float strokeweight){
  for (int i = 0; i < 25; i++){
    for (int j = 0; j < 32; j++){
      pushMatrix(); 
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx-2*diff + 1, 43 - 3*i, posz, posx - diff - 1, 52 - 3*j, posz);
      popMatrix(); 
    }
  }
  
  for (int i = 0; i < 32; i++){
    for (int j = 0; j < 64; j++){
      pushMatrix(); 
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx-diff + 1 , 52 - 3*i, posz, posx - 1, 107 - 3*j, posz);
      popMatrix(); 
    }
  }
  
  for (int i = 0; i < 64; i++){
    for (int j = 0; j < 32; j++){
      pushMatrix();
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx +1, 107 - 3*i, posz, posx + diff - 1, 52 - 3*j, posz);
      popMatrix();
    }
  }
  for (int i = 0; i < 32; i++){
    for (int j = 0; j < 16; j++){
      pushMatrix();
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx + diff + 1, 52 - 3*i, posz, posx + 2*diff - 1, 26 - 3*j, posz);
      popMatrix();
    }
  }
  
  for (int i = 0; i < 16; i++){
    for (int j = 0; j < 8; j++){
      pushMatrix();
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx + 2*diff + 1, 26 - 3*i, posz, posx + 3*diff- 1, 13 - 3*j, posz);
      popMatrix();
    }
  }
  
  for (int i = 0; i < 8; i++){
    for (int j = 0; j < 4; j++){
      pushMatrix();
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx + 3*diff + 1, 13 - 3*i, posz, posx + 4*diff - 1, 6 - 3*j, posz);
      popMatrix();
    }
  }
  
  for (int i = 0; i < 4; i++){
    for (int j = 0; j < 1; j++){
      pushMatrix();
      stroke(linecolor);
      strokeWeight(strokeweight);
      line(posx + 4*diff + 1, 6 - 3*i, posz, posx + 5*diff - 1, 1.5 - 3*j, posz);
      popMatrix();
    }
  }
}





void draw_mybox(int myposx, int myposy, int myposz, color mycolor, int mysize){
  pushMatrix();
  
  strokeWeight(1); 
  stroke(mycolor);
  noFill();
  translate(myposx, myposy, myposz); 
  box(mysize);
  
  popMatrix();
}


void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}


void draw_nn_points(int num_loop, color mycolor, int index, int posx, float posy, int posz, int diff){
  for (int i = 0; i < num_loop; i++){
    float ballscale = nn_row.getFloat(index);
    ballscale = map(log(ballscale + 2), log(weight_range[index*2] + 2), log(weight_range[index*2 + 1]+2), 10, 20);
    
    if (weight_range[index*2 + 1] == weight_range[index*2]){
      ballscale = 0;
    }
    pushMatrix();
    stroke(mycolor);
    translate((1-(ballscale))* (posx + diff), (1 - ballscale) * (posy + 3*i),  (1 - ballscale)* posz);
    scale(ballscale);
    point(posx + diff, posy+3*i, posz);
    popMatrix();
    
    index += 1;
  }
}



void mouse_nn_interact(float X_axis, float Y_axis, float Z_axis, 
String in_label, color ori_color) {
  float mouseObjectDistance = 
  sq(mouseX-screenX(X_axis, Y_axis, Z_axis))+sq(mouseY-screenY(X_axis, Y_axis, Z_axis)); 
      if (mouseObjectDistance < 20){ 
        pushMatrix();
        fill(#75a1be);
        translate(-82,-35, -80);
        textSize(30);
        scale(0.1);
        text(in_label, 0,0, 0);
        popMatrix();
        stroke(255);
      } 
      else{
        stroke(ori_color);
      }
}
      
