/*************************************************************************************
Data Visualization               
Tested in Processing 4                                   
                                                     
Author: SIMING, SU                       
Supervisor: George Legrady                               
*************************************************************************************/
import peasy.*;
import controlP5.*;
ControlP5 cp5;
PeasyCam cam;


ArrayList <Heart> hearts = new ArrayList<Heart>();

Table dating_table;



int dating_numRow;

// range part 
int[] feature_range = {18,28,0,30,0,164425,0,9288,0,241,0,1,0,1,0,1,0,1,0,1,0,1,
0,1,0,9,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1};

int[] weight_range = {12, 1872, 0, 1438, 0, 0, 0, 38, 0, 232, 0, 0, 0, 
10417, 0, 136, 0, 0, 0, 2978, 0, 17363, 0, 29, 0, 1103, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 18, 0, 485, 0, 7, 0, 0, 0, 2397, 0, 0, 0, 10027, 0, 59, 0, 
13698, 0, 0, 0, 3083, 0, 154, 0, 4426, 0, 39, 0, 759, 0, 1947, 0, 11149, 
0, 0, 0, 0, 0, 115, 0, 15834, 0, 175, 0, 11641, 0, 118, 0, 246, 0, 8249, 
0, 43, 0, 228, 0, 88, 0, 174, 0, 0, 0, 85, 0, 142, 0, 709, 0, 9538, 0, 10914, 
0, 0, 0, 0, 0, 34, 0, 78, 0, 0, 0, 12731, 0, 0, 0, 173, 0, 0, 0, 143, 0, 16732, 
0, 13062, 0, 15009, 0, 10036, 0, 0, 0, 12473, 0, 8765, 0, 2554, 0, 0, 0, 0, 0, 
13258, 0, 2635, 0, 0, 0, 0, 0, 2586, 0, 28, 0, 0, 0, 0, 0, 9364, 0, 396, 0, 68, 
0, 14478, 0, 9435, 0, 0, 0, 111, 0, 11534, 0, 76, 0, 0, 0, 1893, 0, 0, 0, 0, 0, 
0, 0, 11340, 0, 0, 0, 35654, 0, 0, 0, 0, 0, 608, 0, 208, 0, 0, 0, 225, 0, 26345, 
0, 527, 0, 580, 0, 0, 0, 24099, 0, 587, 0, 420, 0, 0, 0, 0, 0, 0, 0, 42558, 0, 0, 
0, 41, 0, 332, 0, 40912, 0, 36, 0, 9707, 0, 0, 0, 0, 0, 25253, 0, 49705, 0, 0, 0, 
0, 0, 68, 0, 29649, 0, 50161, 0, 0, 0, 0, 0, 30686, 0, 35625, 0, 0, 0, 167, 0, 
27672, 0, 31816, 0, 36303, 0, 62411, 0, 127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
46893, 0, 0, 0, 30, 0, 0, 0, 48438, 0, 43904, 0, 0, 0, 21085, 0, 19427, 0, 
19107, -1, 8229};


// neural network part
int nn_numRow;
int nn_table_numRow;

TableRow nn_row; 
TableRow nn_data_row;

Table nn_process;
Table nn_table;

boolean NeuralProcess;
boolean LinearProcess;
boolean XGBProcess;


// rate part
float theta = 0;
int rate = 0;
int rate1 = 0;
int nn_FPS = 25;
int linear_FPS = 25; 

ArrayList <Integer> rate_list = new ArrayList<Integer>();
ArrayList <Integer> rate1_list = new ArrayList<Integer>();
ArrayList <Integer> rate2_list = new ArrayList<Integer>();


// key control
boolean residual = false;
boolean nn_hide= false;
boolean change = false;
int rate_change = 1;

void setup() {
    
  //fullScreen(P3D);
  //size(1680, 1680, P3D);
  fullScreen(P3D);
  NeuralProcess = false;
  LinearProcess = false;
  XGBProcess = false;

  cam = new PeasyCam(this, 200);
  cp5 = new ControlP5(this);
  
  // CP5 controller 
  cp5.addToggle("NeuralProcess").setPosition(100,100).setSize(50, 30);
  cp5.addToggle("LinearProcess").setPosition(100,150).setSize(50, 30);
  cp5.addToggle("XGBProcess").setPosition(100,200).setSize(50, 30);
  cp5.addSlider("linear_FPS").setRange(1,100).setPosition(100, 250).setSize(80, 40);
  cp5.addSlider("nn_FPS").setRange(1, 100).setPosition(100, 300).setSize(80, 40);
  cp5.setAutoDraw(false);
 
  //Added on Jan 30th by Rodger Luo
  float  cameraZ = (height/2.0) / tan(PI*60.0/360.0);
  perspective(PI/3.0, width/height, 0.001, cameraZ*10.0); 
  //Finished adding 
  dating_table = loadTable("mydata.csv", "header");
  nn_process = loadTable("nn_process.csv", "header");
  nn_table = loadTable("nn_origin.csv", "header");
  
  dating_numRow = dating_table.getRowCount();
  nn_numRow = nn_process.getRowCount();
  nn_table_numRow = nn_table.getRowCount();
   

  for(int i=0; i<dating_numRow; i++){
    float pos_X = dating_table.getFloat(i, 2);
    float pos_Y = dating_table.getFloat(i, 3);
    float pos_Z = dating_table.getFloat(i, 5);
    float scale = dating_table.getFloat(i, 4);
    float linear_scale = dating_table.getFloat(i, 20);
    float xgb_scale = dating_table.getFloat(i, 21);
    float linear_residual = dating_table.getFloat(i, 22);
    float xgb_residual = dating_table.getFloat(i, 23);
    hearts.add(new Heart(pos_X, pos_Y, pos_Z, scale, linear_scale, xgb_scale, linear_residual, xgb_residual));
  }
}

void draw() {
  background(0);  
  if (!NeuralProcess && !LinearProcess && !XGBProcess && residual == false){
    background(0);
    draw_total_label(#ffa600, 27,-70, 0 ,"Linear Regression");
    draw_total_label(#346888, -11, 78,0, "Neural Network");
    draw_total_label(#7a5195, -42, -60,0, "XGBoost");
    draw_operation_label();
    // Neural Network Points
    for (int i = 0; i < dating_numRow; i++){
      TableRow nn_rate_row = nn_process.getRow(i);
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -21, 21);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -21, 21);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -21, 21);
      float scale_axis = map(log(nn_rate_row.getFloat(156) + 1), 0, 9.2, 0,15);
      
      pushMatrix();
      stroke(#346888); 
      translate(0, 46, 0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis);  
      popMatrix();
    }
    
    // Original points
    for (int i = 0; i < dating_numRow; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -25, 25);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -25, 25);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -25, 25);
      float scale_axis = map(log(hearts.get(i).scale + 1), 0, 9.2, 0, 15);
      
      pushMatrix();
      stroke(#ef5675);
      translate(0, 0 ,0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();
    }
    
    // Linear Regression points
    for (int i = 0; i < dating_numRow; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -18, 18);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -18, 18);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -18, 18);
      float scale_axis = map(log(hearts.get(i).linear_scale + 1), 0, 9.2, 0,15);
      
      pushMatrix();
      stroke(#ffa600);
      translate(35, -43,0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();    
    }
    
    
    // XGB boost points  
    for (int i = 0; i < dating_numRow; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -14, 14);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -14, 14);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -14, 14);
      float scale_axis = map(log(hearts.get(i).xgb_scale + 1), 0, 9.2, 0,15);
      
      pushMatrix();
      stroke(#7a5195);
      translate(-35, -39,0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();    
    }

    
    draw_mybox(-35, -39, 0, #7a5195, 28); 
    draw_mybox(35, -43, 0, #ffa600, 36); 
    draw_mybox(0,46, 0, #346888, 42);
    draw_mybox(0, 0, 0, #ef5675, 50);
  }

  if (residual == true){
    background(0);
    // Neural Network Points
    for (int i = 0; i < dating_numRow; i++){
      TableRow nn_rate_row = nn_process.getRow(i);
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -21, 21);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -21, 21);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -21, 21);
      float scale_axis = map(log(abs(nn_rate_row.getFloat(156) - hearts.get(i).xgb_scale) + 1), 0, 9, 0, 10);
      
      pushMatrix();
      stroke(#346888); 
      translate(0, 46, 0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis);  
      popMatrix();
    }
    for (int i = 0; i < dating_numRow; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -18, 18);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -18, 18);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -18, 18);
      float scale_axis = map(log(hearts.get(i).linear_residual + 1), 0, 9, 0,10);
      
      pushMatrix();
      stroke(#ffa600);
      translate(35, -43,0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();    
    }
    
     //XGB boost points  
    for (int i = 0; i < dating_numRow; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -14, 14);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -14, 14);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -14, 14);
      float scale_axis = map(log(hearts.get(i).xgb_residual + 1), 0, 9, 0,10);
      
      pushMatrix();
      stroke(#7a5195);
      translate(-35, -39,0);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();    
    }
    
    draw_mybox(-35, -39, 0, #7a5195, 28); 
    draw_mybox(35, -43, 0, #ffa600, 36); 
    draw_mybox(0,46, 0, #346888, 42);
  
  } 
  
  if (NeuralProcess){
    background(0);
    label_operation(#346888);
    draw_linear_labels(#346888);
    nn_data_row = nn_table.getRow(rate);
    nn_row = nn_process.getRow(rate);
    
    if (!nn_hide){
    for (int i = 0; i < rate; i++){
      TableRow nn_rate_row = nn_process.getRow(i);
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -60, 60);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -60, 60);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -60, 60);
      float scale_axis = map(log(nn_rate_row.getFloat(156) + 1), -0.1, 9.2, 0, 60);
    
      pushMatrix();
      mouse_interact(X_axis, Y_axis, Z_axis, 
      hearts.get(i).pos_X, hearts.get(i).pos_Y, hearts.get(i).pos_Z,
      nn_rate_row.getFloat(156), #3d708f);     
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis);  
      popMatrix();
    }
    }
    draw_mybox(0,0,0, #3d708f, 120);  
    draw_nn_work(-20,-80, 30, #004c6d, nn_data_row);
    connect_network(-20, -80, 30, #004c6d, 0.5);
    
    rate_list.add(rate);
    
    if (rate_list.size() > nn_FPS){
      rate += rate_change;
      rate_list.clear(); 
      }
    if (rate == 3991){
      rate = 0;
    }
    
  }
  
  if (LinearProcess){
    background(0); 
    label_operation(#ffa600); 
    draw_linear_labels(#ffa600);
    linear_input_label();
    nn_data_row = nn_table.getRow(rate1);
    
    for (int i = 0; i < rate1; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -60, 60);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -60, 60);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -60, 60);
      float scale_axis = map(log(hearts.get(i).linear_scale + 1), 0, 9.2, 0, 30);
      
      pushMatrix();
      mouse_interact(X_axis, Y_axis, Z_axis, 
      hearts.get(i).pos_X, hearts.get(i).pos_Y, hearts.get(i).pos_Z,
      hearts.get(i).linear_scale, #ffa600); 
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();    
    }
    
    float new_scale_axis = map(log(hearts.get(rate1).linear_scale + 1), 0, 9.2, 0, 30);
    pushMatrix();
    stroke(#ffa600);
    translate(-75, -89, 0);
    //translate((1-new_scale_axis)* -63, (1 - new_scale_axis) * -80,  0);
    scale(new_scale_axis);
    point(0,0,0); 
    popMatrix();    
    
    draw_formula(-73,-90, 0);
    insert_number(nn_data_row, -6);
    draw_mybox(0,0,0,#ffa600,120);

    
    rate1_list.add(rate);
    if (rate1_list.size() > linear_FPS){
      rate1 += rate_change;
      rate1_list.clear(); 
      }
      
    if (rate1 == 3991){
      rate1 = 0;
    }
  }
  
  if (XGBProcess){
    background(0); 
    label_operation(#7a5195);
    draw_linear_labels(#7a5195);
    for (int i = 0; i < dating_numRow; i++){
      float X_axis = map(log(hearts.get(i).pos_X + 1), 0, 3.5, -60, 60);
      float Y_axis = map(log(hearts.get(i).pos_Y + 1), 0, 12.1, -60, 60);
      float Z_axis = map(log(hearts.get(i).pos_Z + 1), 0, 5.5, -60, 60);
      float scale_axis = map(log(hearts.get(i).xgb_scale + 1), 0, 9.2, 0,30);
      
      pushMatrix();
      mouse_interact(X_axis, Y_axis, Z_axis, 
      hearts.get(i).pos_X, hearts.get(i).pos_Y, hearts.get(i).pos_Z, 
      hearts.get(i).xgb_scale, #7a5195);
      translate((1-scale_axis)* X_axis, (1 - scale_axis) * Y_axis,  (1 - scale_axis)* Z_axis);
      scale(scale_axis);
      point(X_axis, Y_axis, Z_axis); 
      popMatrix();    
    }
    draw_mybox(0,0,0,#7a5195,120);
    
  }
  
  
  
  gui();
}


void keyPressed(){
  if (key == 'r'){
    residual = !residual;
  }
  
  if (key == 'h'){
    nn_hide = !nn_hide;
  }
  
  if (key == ' '){
    rate1 = 0; 
    rate = 0;
  }
  if (key == 's'){
    change = !change;
    if (change){
      rate_change = 0;
    }
    else{
      rate_change = 1;
    }
  }
}
